Index: Singular/LIB/monomial.lib
===================================================================
--- Singular/LIB/monomial.lib	(revision 7f8587b3752e6d6a92df017bafdfb3d03198e66b)
+++ Singular/LIB/monomial.lib	(revision abbd22e3508e31d6abd926f194f4cb62f9365784)
@@ -40,7 +40,7 @@
 ";
 LIB "poly.lib";  // Para "maxdeg1" en "isprimeMon"
-//---------------------------------------------------------------------------        
+//---------------------------------------------------------------------------
 //-----------------------   INTERNOS    -------------------------------------
-//---------------------------------------------------------------------------        
+//---------------------------------------------------------------------------
 /////////////////////////////////////////////////////////////////////////////
 //
@@ -54,11 +54,11 @@
   int i,n;
   n = ncols(I);
-  for (i = 1 ; i <= n ; i ++)
-    {
-      if ( size(I[i]) > 1 )
-        {
-          return (0);
-        }
-    }
+  for (i = n ; i >= 1 ; i --)
+  {
+    if ( size(I[i]) > 1 )
+    {
+      return (0);
+    }
+  }
   return (1);
 }
@@ -80,17 +80,17 @@
   J = 0;
 
-  int sizI = size(I);
+  int sizI = ncols(I);
   for (i = 1 ; i <= sizI ; i++)
-    {
-      g = gcdMon(I[i],f);
-      // Cociente de dos monomios: restamos los exponentes, y en el
-      // denominador va el mcd
-      v = leadexp(I[i]) - leadexp(g);
-      generator = monomial (v);
-      if (membershipMon(generator,J) == 0)
-        {
-          J=J,generator;
-        }
-    }
+  {
+    g = gcd(I[i],f);
+    // Cociente de dos monomios: restamos los exponentes, y en el
+    // denominador va el mcd
+    v = leadexp(I[i]) - leadexp(g);
+    generator = monomial (v);
+    if (membershipMon(generator,J) == 0)
+    {
+      J=J,generator;
+    }
+  }
   // minimal monomial basis
   return ( minbase(J) );
@@ -107,26 +107,25 @@
 "
 {
-  def R = basering;
   // Variables
-  int nvar,i,cont,sop;
+  int i,cont,sop;
   intvec expf;
-  nvar = nvars(R);
+  int nvar = nvars(basering);
   expf = leadexp(f);
   cont = 0;
   // cont va a contar el numero de componentes del vector no nulas.
   // En sop guardamos el subindice de la componente no nula.
-  for (i = 1 ; i <= nvar ; i++)
-    {
-      if (expf[i] > 0)
-        {
-          cont ++;
-          sop = i;
-          // Si cont > 1 ==> aparece mas de una variable, devolvemos 0
-          if (cont > 1)
-            {
-              return (0);
-            }
-        }
-    }
+  for (i = nvar ; i >= 1 ; i--)
+  {
+    if (expf[i] > 0)
+    {
+      cont ++;
+      sop = i;
+      // Si cont > 1 ==> aparece mas de una variable, devolvemos 0
+      if (cont > 1)
+      {
+        return (0);
+      }
+    }
+  }
   return(sop);
 }
@@ -145,31 +144,30 @@
 "
 {
-  def R = basering;
   // Variables
   int sizI,i,nvar,j,sum;
   intvec w,exp;
-  sizI = size(I);
-  nvar = nvars(R);
+  sizI = ncols(I);
+  nvar = nvars(basering);
   for (i = 1 ; i <= sizI ; i++)
-    {
-      sum = 0;
-      exp = leadexp(I[i]);
-      for (j = 1 ; j <= nvar ; j++)
-        {
-          // Al menos tenemos una variable en cada generador, luego
-          // entramos minimo 1 vez, luego sum >= 1.
-          if (exp[j] <> 0)
-            {
-              sum = sum + 1;
-              w[sum] = j;
-            }
-        }
-      // Si hay mas de una variable la suma sera mayor que 1; y ya
-      // sabemos que I no es irreducible.
-      if (sum <> 1)
-        {
-          return(i,w);
-        }
-    }
+  {
+    sum = 0;
+    exp = leadexp(I[i]);
+    for (j = 1 ; j <= nvar ; j++)
+    {
+      // Al menos tenemos una variable en cada generador, luego
+      // entramos minimo 1 vez, luego sum >= 1.
+      if (exp[j] <> 0)
+      {
+        sum++;
+        w[sum] = j;
+      }
+    }
+    // Si hay mas de una variable la suma sera mayor que 1; y ya
+    // sabemos que I no es irreducible.
+    if (sum <> 1)
+    {
+      return(i,w);
+    }
+  }
   return(1);
 }
@@ -186,15 +184,15 @@
   poly f;
   int i,resp;
-  int n = size(I);
+  int n = ncols(I);
   // Desde que haya un generador que no pertenzca al ideal, ya no se da
   // el contenido y terminamos.
   for (i = 1 ; i <= n ; i++)
-    {
-      resp = membershipMon(I[i],J);
-      if (resp == 0)
-        {
-          return(0);
-        }
-    }
+  {
+    resp = membershipMon(I[i],J);
+    if (resp == 0)
+    {
+      return(0);
+    }
+  }
   return(1);
 }
@@ -215,22 +213,23 @@
   // que vienen dados por el sistema minimal de generadores.
   if (size(I) <> size(J))
-    {
-      return(0);
-    }
-  n = size(I);
+  {
+    return(0);
+  }
   // Como ambos ideales vienen dados por la base minimal, no vamos a
   // tener problemas con que comparemos uno de I con otro de J, pues
   // no puede haber generadores iguales en el mismo ideal.
   // Si los ordenamos, se puede comparar uno a uno
-  I = sort(I)[1];
-  J = sort(J)[1];
-  for (i = 1 ; i <= n ; i++)
-    {
-      if (I[i] <> J[i])
-        {
-          return(0);
-        }
-    }
-  return(1);
+  return(matrix( sort(I)[1])==matrix(sort(J)[1]));
+  //n = size(I);
+  //I = sort(I)[1];
+  //J = sort(J)[1];
+  //for (i = 1 ; i <= n ; i++)
+  //{
+  //  if (I[i] <> J[i])
+  //  {
+  //    return(0);
+  //  }
+  //}
+  //return(1);
 }
 /////////////////////////////////////////////////////////////////////////////
@@ -245,34 +244,27 @@
 {
   // Cambiamos de anillo
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
+  int nvar = nvars(basering);
   // Variables
   int i,cont;
   intvec exp;
   ideal rad;
-  ideal I = fetch(R,I);
   // Como en cada generador aparece solo una variable,  y ademas la
   // la misma variable no va a aparecer dos veces, es suficiente
   // con sumar los exponentes de todos los generadores para saber que
   // variables aparecen.
-  int n = size(I);
+  int n = ncols(I);
   for (i = 1 ; i <= n ; i++)
-    {
-      exp = exp + leadexp (I[i]);
-    }
+  {
+    exp = exp + leadexp (I[i]);
+  }
   cont = 1;
   for (i = 1 ; i <= nvar ; i++)
-    {
-      if (exp[i] <> 0)
-        {
-          rad[cont] = x(i);
-          cont ++;
-        }
-    }
-  setring R;
-  ideal rad = fetch(R1,rad);
-  kill R1;
+  {
+    if (exp[i] <> 0)
+    {
+      rad[cont] = var(i);
+      cont ++;
+    }
+  }
   return (rad);
 }
@@ -292,11 +284,10 @@
 "
 {
-  def R = basering;
   // Variables
   int control,nvar,i,sub_in,l,j;
   intvec v,w,exp_gen;
   // El ideal ya entra generado por el sistema minimal
-  nvar = nvars(R);
-  int sizI = size(I);
+  nvar = nvars(basering);
+  int sizI = ncols(I);
   v[nvar] = 0;
   int cont = 1;
@@ -305,40 +296,40 @@
   // generadores de I que hay que comprobar.
   for (i = 1 ; i <= sizI ; i++ )
-    {
-      sub_in = soporte(I[i]);
-      if ( sub_in <> 0)
-        {
-          v[sub_in] = 1;
-        }
-      else
-        {
-          w[cont] = i;
-          cont ++;
-        }
-    }
+  {
+    sub_in = soporte(I[i]);
+    if ( sub_in <> 0)
+    {
+      v[sub_in] = 1;
+    }
+    else
+    {
+      w[cont] = i;
+      cont ++;
+    }
+  }
   l = size(w);
   // No hay ningun generador que tenga productos de variables, luego
   //  este ideal ya es primario.
   if (l == 1 && w[1] == 0)
-    {
-      return (1);
-    }
+  {
+    return (1);
+  }
   for (i = 1 ; i <= l ; i++)
-    {
-      exp_gen = leadexp(I[w[i]]);
-      // Ahora hay que ver que valor tiene el exponente de los
-      // generadores oportunos en la posicion que es cero dentro del
-      // vector v.
-      for (j = 1 ; j <= nvar ; j++)
-        {
-          if (v[j] == 0)
-            {
-              if (exp_gen[j] <> 0)
-                {
-                  return (0,j,w);
-                }
-            }
-        }
-    }
+  {
+    exp_gen = leadexp(I[w[i]]);
+    // Ahora hay que ver que valor tiene el exponente de los
+    // generadores oportunos en la posicion que es cero dentro del
+    // vector v.
+    for (j = 1 ; j <= nvar ; j++)
+    {
+      if (v[j] == 0)
+      {
+        if (exp_gen[j] <> 0)
+        {
+          return (0,j,w);
+        }
+      }
+    }
+  }
   // Si hemos llegado hasta aqui hemos recorrido todo el ideal y por tanto
   // es primario.
@@ -371,11 +362,11 @@
   max = 0;
   for (i = 1 ; i <= n ; i++)
-    {
-      exp = leadexp (I[v[i+2]]);
-      if (exp[v[2]] > max)
-        {
-          max = exp[v[2]];
-        }
-    }
+  {
+    exp = leadexp (I[v[i+2]]);
+    if (exp[v[2]] > max)
+    {
+      max = exp[v[2]];
+    }
+  }
   return (max);
 }
@@ -396,24 +387,24 @@
   int sizl = size(l);
   for (i = 1 ; i <= sizl ; i++)
-    {
-      J = 1;
-      for (j = 1 ; j <= sizl ; j++)
-        {
-          // Hacemos la interseccion de todos los ideales menos uno y
-          // luego se estudia el contenido.
-          if (j <> i)
-            {
-              J = intersect (J,l[j]);
-            }
-        }
-      J = minbase(J);
-      resp = contents(J,l[i]);
-      if (resp == 1)
-        {
-          l = delete (l,i);
-          i--;
-          sizl = size(l);
-        }
-    }
+  {
+    J = 1;
+    for (j = 1 ; j <= sizl ; j++)
+    {
+      // Hacemos la interseccion de todos los ideales menos uno y
+      // luego se estudia el contenido.
+      if (j <> i)
+      {
+        J = intersect (J,l[j]);
+      }
+    }
+    J = minbase(J);
+    resp = contents(J,l[i]);
+    if (resp == 1)
+    {
+      l = delete (l,i);
+      i--;
+      sizl = size(l);
+    }
+  }
   return (l);
 }
@@ -432,8 +423,5 @@
 {
   // Cambiamos de anillo
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
+  int nvar = nvars(basering);
   // Variables
   int i,j;
@@ -441,29 +429,25 @@
   list l;
   ideal J;
-  ideal I = fetch (R,I);
-  int sizI = size(I);
+  int sizI = ncols(I);
   // Vamos a tener tantas componentes como generadores minimales tiene el
   // ideal, por eso el bucle es de 1 a size(I).
- for (i = 1 ; i <= sizI ; i++)
-   {
-     J = 0;
-     exp_I = leadexp (I[i]);
-     for (j = 1 ; j <= nvar ; j++)
-       {
-         if (exp_I[j] <> 0)
-           {
-             exp[j] = v[j] + 1 - exp_I[j];
-             J = J, x(j)^exp[j];
-           }
-       }
-     // Tenemos siempre un cero por la inicializacion de J, entonces
-     // lo quitamos.
-     J = simplify (J,2);
-     l = insert (l,J);
-   }
- setring R;
- list l = fetch (R1,l);
- kill R1;
- return (l);
+  for (i = 1 ; i <= sizI ; i++)
+  {
+    J = 0;
+    exp_I = leadexp (I[i]);
+    for (j = 1 ; j <= nvar ; j++)
+    {
+      if (exp_I[j] <> 0)
+      {
+        exp[j] = v[j] + 1 - exp_I[j];
+        J = J, var(j)^exp[j];
+      }
+    }
+    // Tenemos siempre un cero por la inicializacion de J, entonces
+    // lo quitamos.
+    J = simplify (J,2);
+    l = insert (l,J);
+  }
+  return (l);
 }
 /////////////////////////////////////////////////////////////////////////////
@@ -485,7 +469,7 @@
   sizl1 = size(l1);
   for (i = 1 ; i <= sizl1 ; i++)
-    {
-      l2[i] = radicalAux (l1[i]);
-    }
+  {
+    l2[i] = radicalAux (l1[i]);
+  }
   sizl2 = size(l2);
   int sizl2i, sizl2j;
@@ -495,31 +479,31 @@
   // l3 = primary components list
   for (i = 1 ; i <= sizl1 ; i++)
-    {
-      J = l2[i];
-      sizl2i = size(l2[i]);
-      K = l1[i];
-      for (j = i+1 ; j <= sizl2 ; j++)
-        {
-          sizl2j = size(l2[j]);
-          if (sizl2i == sizl2j)
-            {
-              if (equal (J,l2[j]) == 1)
-                {
-                  K = minbase(intersect (K,l1[j]));
-                  l1 = delete (l1,j);
-                  sizl1 = size(l1);
-                  l2 = delete (l2,j);
-                  sizl2 = size(l2);
-                  j--;
-                }
-            }
-        }
-      l3 = insert (l3,K);
-    }
+  {
+    J = l2[i];
+    sizl2i = size(l2[i]);
+    K = l1[i];
+    for (j = i+1 ; j <= sizl2 ; j++)
+    {
+      sizl2j = size(l2[j]);
+      if (sizl2i == sizl2j)
+      {
+        if (equal (J,l2[j]) == 1)
+        {
+          K = minbase(intersect (K,l1[j]));
+          l1 = delete (l1,j);
+          sizl1 = size(l1);
+          l2 = delete (l2,j);
+          sizl2 = size(l2);
+          j--;
+        }
+      }
+    }
+    l3 = insert (l3,K);
+  }
   return (l3);
 }
 /////////////////////////////////////////////////////////////////////////////
 //
-static proc isMinimal (ideal I)        
+static proc isMinimal (ideal I)
 "
 USAGE:    isMinimal (I); I ideal.
@@ -535,50 +519,50 @@
   I = simplify(I,2);
   int resp = 1;
-  int sizI = size(I);
+  int sizI = ncols(I);
   // Cambiamos el tamano de I cuando eliminamos generadores
   for (i = 1 ; i <= sizI ; i++)
-    {
-      if (sizI <> 1)
-        {
-          if (i == 1)
-            {
-              J = I[2..sizI];
-            }
-          else
-            {
-              if (i > 1 && i < sizI)
-                {
-                  J = I[1..i-1], I[i+1..sizI];
-                }
-              else
-                {
-                  J = I[1..sizI-1];
-                }
-            }
-          // Si quitamos el generador del lugar "i", luego el que
-          // ocupa ahora el lugar "i" es el "i+1", de ahi que restemos
-          // 1 al i para volver al for de manera que recorramos los
-          // generadores como debemos.                
-          if (membershipMon(I[i],J) == 1)
-            {
-              resp = 0;
-              I = J;
-              i--;
-              sizI = size(I);
-            }
-        }
-    }
+  {
+    if (sizI <> 1)
+    {
+      if (i == 1)
+      {
+        J = I[2..sizI];
+      }
+      else
+      {
+        if (i > 1 && i < sizI)
+        {
+          J = I[1..i-1], I[i+1..sizI];
+        }
+        else
+        {
+          J = I[1..sizI-1];
+        }
+      }
+      // Si quitamos el generador del lugar "i", luego el que
+      // ocupa ahora el lugar "i" es el "i+1", de ahi que restemos
+      // 1 al i para volver al for de manera que recorramos los
+      // generadores como debemos.
+      if (membershipMon(I[i],J) == 1)
+      {
+        resp = 0;
+        I = J;
+        i--;
+        sizI = size(I);
+      }
+    }
+  }
   if (resp == 1)
-    {
-      return (1);
-    }
+  {
+    return (1);
+  }
   else
-    {
-      return (0,I);
-    }
+  {
+    return (0,I);
+  }
 }
 /////////////////////////////////////////////////////////////////////////////
-//        
-static proc isMonomialGB (ideal I)        
+//
+static proc isMonomialGB (ideal I)
 "
 USAGE:    isMonomialGB (I); I ideal.
@@ -591,38 +575,28 @@
 "
 {
-  // Cambiamos de anillo
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
-        
   // Variables
-  int resp,m,k;
-  // Queremos la base de Grobner reducida, para uncidad.
-  ideal I = fetch(R,I);
-  option(redSB);        
+  int resp;
   // Si el ideal es cero, no es monomial.
   if ( size(I) == 0)
-    {
-      return(0);
-    }
+  {
+    return(0);
+  }
+  // Queremos la base de Grobner reducida, para uncidad.
+  intvec save_opt=option(get);
+  option(redSB);
   // Base de Grobner
   I = std(I);
+  option(set,save_opt);
   // Una vez que tenemos la GB, no es mas que comprobar que el ideal
   // esta generado por monomios.
   resp = checkIdeal(I);
   if (resp == 0)
-    {
-      setring R;
-      kill R1;
-      return (0);
-    }
+  {
+    return (0);
+  }
   else
-    {
-      setring R;
-      I = fetch (R1,I);
-      kill R1;
-      return (1,I);
-    }
+  {
+    return (1,I);
+  }
 }
 /////////////////////////////////////////////////////////////////////////////
@@ -635,7 +609,4 @@
 proc areEqual(list l1,list l2)
 {
-  def R = basering;
-  l1 = fetch(R,l1);
-  l2 = fetch(R,l2);
   int i,j,sizIdeal;
   poly generator;
@@ -643,24 +614,24 @@
   int sizl1 = size(l1);
   for (i = 1 ; i <= sizl1 ; i ++)
-    {
-      sizIdeal = size(l1[i]);
-      generator = 1;
-      for (j = 1 ; j <= sizIdeal ; j ++)
-        {
-          generator = generator*l1[i][j];
-        }
-      l1Ideal[i] = generator;
-    }
+  {
+    sizIdeal = size(l1[i]);
+    generator = 1;
+    for (j = 1 ; j <= sizIdeal ; j ++)
+    {
+      generator = generator*l1[i][j];
+    }
+    l1Ideal[i] = generator;
+  }
   int sizl2 = size(l2);
   for (i = 1 ; i <= sizl2 ; i ++)
-    {
-      sizIdeal = size(l2[i]);
-      generator = 1;
-      for (j = 1 ; j <= sizIdeal ; j ++)
-        {
-          generator = generator*l2[i][j];
-        }
-      l2Ideal[i] = generator;
-    }
+  {
+    sizIdeal = size(l2[i]);
+    generator = 1;
+    for (j = 1 ; j <= sizIdeal ; j ++)
+    {
+      generator = generator*l2[i][j];
+    }
+    l2Ideal[i] = generator;
+  }
   return (equal(l1Ideal,l2Ideal));
 }
@@ -670,6 +641,6 @@
 //-------------------------------------------------------------------------//
 /////////////////////////////////////////////////////////////////////////////
-//        
-proc isMonomial (ideal I)        
+//
+proc isMonomial (ideal I)
 "USAGE:    isMonomial (I); I ideal.
 RETURN:   1, if I is monomial ideal; 0, otherwise.
@@ -678,33 +649,26 @@
 "
 {
-  // Cambiamos de anillo
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);        
+  // Si el ideal es cero, no es monomial.
+  if ( size(I) == 0)
+  {
+    return(0);
+  }
+  // Si ya viene dado por sistema de generadores monomiales, devolvemos 1
+  if (checkIdeal (I) == 1)
+  {
+    return(1);
+  }
   // Variables
   int resp,m,k;
   // Queremos la base de Grobner reducida, para uncidad.
-  ideal I = fetch(R,I);
-  option(redSB);        
-  // Si el ideal es cero, no es monomial.
-  if ( size(I) == 0)
-    {
-      return(0);
-    }
-  // Si ya viene dado por sistema de generadores monomiales, devolvemos 1
-  if (checkIdeal (I) == 1)
-    {
-      return(1);
-    }
+  intvec save_opt=option(get);
+  option(redSB);
   // Hallamos GB
   I = std(I);
+  option(set,save_opt);
   // Una vez que tenemos la GB, no es mas que comprobar si el ideal
   // esta generado por monomios.
   resp = checkIdeal(I);
   // Volvemos a dejar el comando "std" devolviendo una GB estandar.
-  option(noredSB);
-  setring R;
-  kill R1;
   return(resp);
 }
@@ -733,44 +697,44 @@
   int control = checkIdeal(I);
   if (control == 0)
-    {
-      return (-1);
-    }
+  {
+    return (-1);
+  }
   // Quitamos los ceros del sistema de generadores.
   I = simplify(I,2);
-  int sizI = size(I);
+  int sizI = ncols(I);
   for (i = 1 ; i <= sizI ; i++)
-    {
-      if (sizI > 1)
-        {
-          if (i == 1)
-            {
-              J = I[2..sizI];
-            }
-          else
-            {
-              if (i > 1 && i < sizI)
-                {
-                  J = I[1..i-1], I[i+1..sizI];
-                }
-              else
-                {
-                  if (i == sizI)
-                    {
-                      J = I[1..sizI-1];
-                    }
-                }
-            }
-          // Si quitamos el generador del lugar "i", luego el que
-          // ocupa ahora el lugar "i" es el "i+1", de ahi que restemos
-          // 1 al i para volver al for de manera que recorramos los
-          // generadores como debemos.        
-          if (membershipMon(I[i],J) == 1)
-            {
-              I = J;
-              i--;
-              sizI = size(I);
-            }
-        }
-    }
+  {
+    if (sizI > 1)
+    {
+      if (i == 1)
+      {
+        J = I[2..sizI];
+      }
+      else
+      {
+        if (i > 1 && i < sizI)
+        {
+          J = I[1..i-1], I[i+1..sizI];
+        }
+        else
+        {
+          if (i == sizI)
+          {
+            J = I[1..sizI-1];
+          }
+        }
+      }
+      // Si quitamos el generador del lugar "i", luego el que
+      // ocupa ahora el lugar "i" es el "i+1", de ahi que restemos
+      // 1 al i para volver al for de manera que recorramos los
+      // generadores como debemos.
+      if (membershipMon(I[i],J) == 1)
+      {
+        I = J;
+        i--;
+        sizI = ncols(I);
+      }
+    }
+  }
   return (I);
 }
@@ -841,26 +805,27 @@
     ERROR ("the input must be 2 monomials.");
   }
-  // Variables.
-  int k;
-  intvec exp;
-  int nvar = nvars(basering);
+  return(f*g/gcd(f,g));
+  //// Variables.
+  //int k;
+  //intvec exp;
+  //int nvar = nvars(basering);
 
-  // No tenemos mas que tomar el mayor exponente.
-  intvec expf = leadexp (f);
-  intvec expg = leadexp (g);
-        
-  for (k = 1 ; k <= nvar ; k ++)
-  {
-    if (expf[k] <= expg[k])
-    {
-      exp[k] = expg[k];
-    }
-    else
-    {
-       exp[k] = expf[k];
-    }
-  }
-  // Transformamos el vector de exponentes al monomio correspondiente.
-  return(monomial (exp));
+  //// No tenemos mas que tomar el mayor exponente.
+  //intvec expf = leadexp (f);
+  //intvec expg = leadexp (g);
+
+  //for (k = 1 ; k <= nvar ; k ++)
+  //{
+  //  if (expf[k] <= expg[k])
+  //  {
+  //    exp[k] = expg[k];
+  //  }
+  //  else
+  //  {
+  //     exp[k] = expf[k];
+  //  }
+  //}
+  //// Transformamos el vector de exponentes al monomio correspondiente.
+  //return(monomial (exp));
 }
 example
@@ -873,5 +838,5 @@
 //////////////////////////////////////////////////////////////////////
 //
-proc membershipMon(poly f,ideal I)        
+proc membershipMon(poly f,ideal I)
 "USAGE:    membershipMon(f,I); f polynomial, I ideal.
 RETURN:   1, if f lies in I; 0 otherwise.
@@ -881,5 +846,4 @@
 "
 {
-  def R = basering;
   // Variables
   int i,j,resp,k,control;
@@ -914,7 +878,7 @@
   // Quitamos ceros.
   I = simplify(I,2);
-  int n = size(I);
+  int n = ncols(I);
   int m = size(f);
-  int nvar = nvars(R);
+  int nvar = nvars(basering);
   for (i=1 ; i<=m ; i++)
   {
@@ -976,5 +940,5 @@
 //////////////////////////////////////////////////////////////////////
 //
-proc intersectMon (ideal I,ideal J)        
+proc intersectMon (ideal I,ideal J)
 "USAGE:    intersectMon (I,J); I,J ideals.
 RETURN:   an ideal, the intersection of I and J.
@@ -991,61 +955,61 @@
   // El ideal trivial no es monomial.
   if ( size(I) == 0 || size(J) == 0)
-    {
-      ERROR("one of the ideals is zero, hence not monomial.");
-    }
+  {
+    ERROR("one of the ideals is zero, hence not monomial.");
+  }
  // COMPROBACIONES
   control = checkIdeal(I);
   if (control == 0)
-    {
-      isMon = isMonomialGB(I);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the first ideal is not monomial.");
-        }
-      else
-        {
-          // Sabemos que I ya viene dado por el sistema minimal de
-          // generadores, aunque aqui no sea necesario.
-          I = isMon[2];
-        }
-    }
+  {
+    isMon = isMonomialGB(I);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the first ideal is not monomial.");
+    }
+    else
+    {
+      // Sabemos que I ya viene dado por el sistema minimal de
+      // generadores, aunque aqui no sea necesario.
+      I = isMon[2];
+    }
+  }
   else
-    {
-      // Los generadores son monomiales, hallamos el sistema minimal
-      I = minbase(I);
-    }
+  {
+    // Los generadores son monomiales, hallamos el sistema minimal
+    I = minbase(I);
+  }
   control = checkIdeal(J);
   if (control == 0)
-    {
-      isMon = isMonomialGB (J);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the second ideal is not monomial.");
-        }
-      else
-        {
-          // Sabemos que J ya viene dado por el sistema minimal de
-          // generadores, aunque aqui no sea necesario.
-          J = isMon[2];
-        }
-    }
+  {
+    isMon = isMonomialGB (J);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the second ideal is not monomial.");
+    }
+    else
+    {
+      // Sabemos que J ya viene dado por el sistema minimal de
+      // generadores, aunque aqui no sea necesario.
+      J = isMon[2];
+    }
+  }
   else
-    {
-      // Los generadores son monomiales,hallamos la base minimal
-      J = minbase(J);
-    }
+  {
+    // Los generadores son monomiales,hallamos la base minimal
+    J = minbase(J);
+  }
   // Hemos asegurado que los ideales sean monomiales.
   // Quitamos ceros de la base para no alargar calculos.
-  int n = size(I);
-  int m = size(J);
+  int n = ncols(I);
+  int m = ncols(J);
   // Hallamos el m.c.m.de cada par de generadores de uno y otro ideal
   // y los a?adimos al ideal interseccion.
   for (i=1 ; i<=n ; i++)
-    {
-      for (j=1 ; j<=m ; j++)
-        {
-          K = K , lcmMon (I[i],J[j]);
-        }
-    }
+  {
+    for (j=1 ; j<=m ; j++)
+    {
+      K = K , lcmMon (I[i],J[j]);
+    }
+  }
   // Devolvemos el ideal ya dado por la base minimal porque sabemos
   // que este procedimiento genera muchos generadores redundantes.
@@ -1061,5 +1025,5 @@
 //////////////////////////////////////////////////////////////////////
 //
-proc quotientMon (ideal I,ideal J)        
+proc quotientMon (ideal I,ideal J)
 "USAGE:    quotientMon (I,J); I,J ideals.
 RETURN:   an ideal, the quotient I:J.
@@ -1076,48 +1040,48 @@
   //COMPROBACIONES
   if (size(I) == 0 || size(J) == 0)
-    {
-      ERROR("one of the ideals is zero, hence not monomial.");
-    }
+  {
+    ERROR("one of the ideals is zero, hence not monomial.");
+  }
   control = checkIdeal(I);
   if (control == 0)
-    {
-      isMon = isMonomialGB (I);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the first ideal is not monomial.");
-        }
-      else
-        {
-          // Sabemos que I ya viene dado por el sistema minimal de
-          // generadores, aunque aqui no sea necesario.
-          I = isMon[2];
-        }
-    }
+  {
+    isMon = isMonomialGB (I);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the first ideal is not monomial.");
+    }
+    else
+    {
+      // Sabemos que I ya viene dado por el sistema minimal de
+      // generadores, aunque aqui no sea necesario.
+      I = isMon[2];
+    }
+  }
   else
-    {
-      // Los generadores son monomiales,hallamos sistema minimal
-      I = minbase(I);
-    }
+  {
+    // Los generadores son monomiales,hallamos sistema minimal
+    I = minbase(I);
+  }
   control = checkIdeal(J);
   if (control == 0)
-    {
-      isMon = isMonomialGB (J);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the second ideal is not monomial.");
-          return (-1);
-        }
-      else
-        {
-          // Sabemos que J ya viene dado por el sistema minimal de
-          // generadores, aunque aqui no sea necesario.
-          J = isMon[2];
-        }
-    }
+  {
+    isMon = isMonomialGB (J);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the second ideal is not monomial.");
+      return (-1);
+    }
+    else
+    {
+      // Sabemos que J ya viene dado por el sistema minimal de
+      // generadores, aunque aqui no sea necesario.
+      J = isMon[2];
+    }
+  }
   else
-    {
-      // Los generadores son monomiales, hallamos el sistema minimal
-      J = minbase(J);
-    }
+  {
+    // Los generadores son monomiales, hallamos el sistema minimal
+    J = minbase(J);
+  }
   // Tenemos los ideales dados por su sistema minimal (aunque no es necesario, ahorra
   // calculos. En K vamos a tener la interseccion de los ideales.
@@ -1126,9 +1090,9 @@
   // Los ideales estan dados por su sistema minimal, con lo que no aparecen ceros.
   // Luego podemos usar size(J).
-  n = size(J);
+  n = ncols(J);
   for (i = 1 ; i <= n ; i++)
-    {
-      K = intersect (K ,quotientIdealMon(I,J[i]));
-    }
+  {
+    K = intersect (K ,quotientIdealMon(I,J[i]));
+  }
   // Aqui tambien surgen muchos generadores que no forman parte de la
   // base minimal del ideal obtenido.
@@ -1154,8 +1118,5 @@
 {
   // Cambiamos de anillo
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
+  int nvar = nvars(basering);
   // Variables
   int i,m,j,control;
@@ -1163,5 +1124,4 @@
   intvec v;
   ideal rad_I;
-  ideal I = fetch(R,I);
   // COMPROBACIONES
   control = checkIdeal(I);
@@ -1169,43 +1129,40 @@
   // que comprobar si el ideal es monomial.
   if (control == 0)
-    {
-      list isMon = isMonomialGB (I);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the ideal is not monomial.");
-        }
-      else
-        {
-          I = isMon[2];
-          // Ya lo tenemos con los generadores monomiales minimales
-        }
-    }
+  {
+    list isMon = isMonomialGB (I);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the ideal is not monomial.");
+    }
+    else
+    {
+      I = isMon[2];
+      // Ya lo tenemos con los generadores monomiales minimales
+    }
+  }
   else
-    {
-      // Generadores monomiales, hallamos sistema minimal
-      I = minbase(I);
-    }
+  {
+    // Generadores monomiales, hallamos sistema minimal
+    I = minbase(I);
+  }
   // Ya tenemos el ideal generado por la BASE MINIMAL MONOMIAL
-  m = size(I);
+  m = ncols(I);
   // Solo hay que poner exponente 1 a todas las variables que tengan
   // exponente >1.
   for (i = 1 ; i <= m ; i++)
-    {
-      v = leadexp(I[i]);
-      f = 1;
-      for (j = 1 ; j <= nvar ; j++)
-        {
-          if (v[j] <> 0)
-            {
-              f = f*x(j);
-            }
-        }
-      rad_I = rad_I,f;
-    }
-  setring R;        
+  {
+    v = leadexp(I[i]);
+    f = 1;
+    for (j = 1 ; j <= nvar ; j++)
+    {
+      if (v[j] <> 0)
+      {
+        f = f*var(j);
+      }
+    }
+    rad_I = rad_I,f;
+  }
   // Hay que devolver el ideal dado por la base minimal, pues se
   // producen muchos generadores redundantes.
-  ideal rad_I = fetch(R1,rad_I);
-  kill R1;
   return( minbase (rad_I));
 }
@@ -1218,5 +1175,5 @@
 //////////////////////////////////////////////////////////////////////
 //
-proc isprimeMon (ideal I)        
+proc isprimeMon (ideal I)
 "USAGE:    isprimeMon (I); I ideal
 RETURN:   1, if I is prime; 0, otherwise.
@@ -1234,27 +1191,27 @@
   // que comprobar si el ideal es monomial.
   if (control == 0)
-    {
-      list isMon = isMonomialGB (I);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the ideal is not monomial.");
-        }
-      else
-        {
-          I = isMon[2];
-          // Ya lo tenemos con los generadores minimales
-        }
-    }
+  {
+    list isMon = isMonomialGB (I);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the ideal is not monomial.");
+    }
+    else
+    {
+      I = isMon[2];
+      // Ya lo tenemos con los generadores minimales
+    }
+  }
   else
-    {
-      // Generadores monomiales, hallamos el sistema minimal
-      I = minbase(I);
-    }
+  {
+    // Generadores monomiales, hallamos el sistema minimal
+    I = minbase(I);
+  }
   // Ya tenemos el ideal generado por la BASE MINIMAL
   if (maxdeg1(I) == 1)
-    {
-      return (1);
-    }
-  return (0);                
+  {
+    return (1);
+  }
+  return (0);
 }
 example
@@ -1268,5 +1225,5 @@
 //////////////////////////////////////////////////////////////////////
 //
-proc isprimaryMon (ideal I)        
+proc isprimaryMon (ideal I)
 "USAGE:    isprimaryMon (I); I ideal
 RETURN:   1, if I is primary; 0, otherwise.
@@ -1276,5 +1233,4 @@
 "
 {
-  def R = basering;
   // Variables
   int nvar,control,m,l,sub_in,i,j,k;
